Package org.eclipse.viatra.addon.querybasedfeatures.runtime.handler

## Class IterationQueryBasedFeature

- java.lang.Object
- - org.eclipse.viatra.addon.querybasedfeatures.runtime.QueryBasedFeature
  - - org.eclipse.viatra.addon.querybasedfeatures.runtime.handler.IterationQueryBasedFeature

- Direct Known Subclasses:
    `SumQueryBasedFeature`

      public abstract class IterationQueryBasedFeature
      extends QueryBasedFeature

- - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `IterationQueryBasedFeature​(org.eclipse.emf.ecore.EStructuralFeature feature, boolean keepCache)` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `afterUpdate()` |
    `protected void` | `beforeUpdate()` |
    `java.lang.Object` | `getValue​(java.lang.Object source)` |
    `abstract java.lang.Object` | `getValueIteration​(java.lang.Object source)` |
    `protected abstract org.eclipse.emf.ecore.impl.ENotificationImpl` | `lostMatchIteration​(IPatternMatch signature)` | Called each time when a match is lost for Iteration kind
    `protected abstract org.eclipse.emf.ecore.impl.ENotificationImpl` | `newMatchIteration​(IPatternMatch signature)` | Called each time when a new match is found for Iteration kind
    `protected void` | `processAppearedMatch​(IPatternMatch signature)` |
    `protected void` | `processDisappearedMatch​(IPatternMatch signature)` |

    - ### Methods inherited from class org.eclipse.viatra.addon.querybasedfeatures.runtime.QueryBasedFeature

      `appendNotificationToList, engineForMatcher, getFeature, getKind, getMatcher, getSourceParamName, getSourceValue, getTargetParamName, getTargetValue, initialize, isCached, isInitialized, setMatcher, setSourceParamName, setTargetParamName, startMonitoring`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### IterationQueryBasedFeature

          protected IterationQueryBasedFeature​(org.eclipse.emf.ecore.EStructuralFeature feature,
                                               boolean keepCache)

      Parameters:
        `feature` -
        `kind` -
        `keepCache` -

  - ### Method Detail

    - #### processDisappearedMatch

          protected void processDisappearedMatch​(IPatternMatch signature)

      Specified by:
        `processDisappearedMatch` in class `QueryBasedFeature`

    - #### processAppearedMatch

          protected void processAppearedMatch​(IPatternMatch signature)

      Specified by:
        `processAppearedMatch` in class `QueryBasedFeature`

    - #### afterUpdate

          protected void afterUpdate()

      Specified by:
        `afterUpdate` in class `QueryBasedFeature`

    - #### beforeUpdate

          protected void beforeUpdate()

      Specified by:
        `beforeUpdate` in class `QueryBasedFeature`

    - #### newMatchIteration

          protected abstract org.eclipse.emf.ecore.impl.ENotificationImpl newMatchIteration​(IPatternMatch signature)

      Called each time when a new match is found for Iteration kind
      Parameters:
        `signature` -
      Returns:
        notification to be sent, if one is necessary

    - #### lostMatchIteration

          protected abstract org.eclipse.emf.ecore.impl.ENotificationImpl lostMatchIteration​(IPatternMatch signature)

      Called each time when a match is lost for Iteration kind
      Parameters:
        `signature` -
      Returns:
        notification to be sent, if one is necessary

    - #### getValue

          public java.lang.Object getValue​(java.lang.Object source)

      Specified by:
        `getValue` in class `QueryBasedFeature`

    - #### getValueIteration

          public abstract java.lang.Object getValueIteration​(java.lang.Object source)